/******************************************************************************/
/*                                                                            */
/*  AVISave.dll - D-Pixed AVI Saver Addin                                     */
/*                                                                            */
/*                           Copyright (C) 2000 -      by ͂߂        */
/*                                          e-mail: hjm@fnmail.com            */
/*                                        homepage: http://hajimetyan.i.am    */
/*                                                                            */
/*                            ŐVł͂_E[hł܂B          */
/*                            Orange System  http://hajimetyan.hoops.ne.jp    */
/*                                                                            */
/******************************************************************************/

//  PW΂̎ᑢPŏvOłB
//  ԂAʂĂ镔Ǝv܂B
//  \[X̓Y͑劽}łB
//  Rgׂ͍Ă܂B

#include <windows.h>		//  Windows̃vOŕK{
#include <vfw.h>			//  Video for WindowgŕK{
#include <tchar.h>			//  TCHARŕK{
#include "dp_add.h"			//  D-Pixed̃AhCŕK{
#include "AVISave.h"		//  \[XX

BOOL CALLBACK SaveDlgProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);

/******************************************************************************/
/*                                                                            */
/*  \                                                                    */
/*                                                                            */
/******************************************************************************/

typedef struct savedlg{
	DWORD	dwRate;
} SAVEDLG;

/******************************************************************************/
/*                                                                            */
/*  AhCE쌠                                                      */
/*                                                                            */
/******************************************************************************/

BOOL _DPGetInfo(DP_ADDININFO *pInfo)
{
	pInfo->dwType = DPADDIN_ENCODER;							//  ǂE
	pInfo->name = "AVI Saver";									//  ǂEˁ`
	pInfo->copyright = "Copyright (C) 2000 by ͂߂";	//  ҁ`炢
	pInfo->addinDescription = "AVIt@C ";			//  ߂
	pInfo->version = "1.00";									//  ΁`
	pInfo->description = "AVI File(*.avi)";						//  ӂE
	pInfo->defExt = "avi";										//  `

	return TRUE;
}

/******************************************************************************/
/*                                                                            */
/*  AhCEC֐                                                      */
/*                                                                            */
/******************************************************************************/

BOOL _DPEncode(LPCSTR fileName,DP_ENCDECINFO *pInfo)
{
	//  ݃JEg
	DWORD		dwCountPic;
	//  wb_[pbg̃TCY
	DWORD		dwHAPSize = sizeof(BITMAPINFOHEADER) + 256 * sizeof(RGBQUAD);
	//  DIBf[^̃TCY
	DWORD		dwDIBDataSize;
	//  Xg[i_CAOŐݒł悤ɂ\j
	AVISTREAMINFO	aviStreamInfo = {streamtypeVIDEO,
									mmioFOURCC('D','I','B',' '),
									0,0,0,0,
									1,15,0,
									(pInfo->nPicture - 1),
									0,0,
									(DWORD)-1,
									0,
									{0, 0, pInfo->pDibBuf[0]->biWidth, pInfo->pDibBuf[0]->biHeight},
									0,
									0,
									_T("޵")};
	PAVIFILE		paviFile;				//  AVI Filẽ|C^
	PAVISTREAM		paviStream;				//  AVI Stream̃|C^
	
	HINSTANCE		hInst;
	//  _CAOƂ̂ƂɎg
	static SAVEDLG	saveInfo;

	//  DIBf[^vZ
	dwDIBDataSize = pInfo->pDibBuf[0]->biWidth;
	dwDIBDataSize += 3;
	dwDIBDataSize &= 0xfffffffc;
	dwDIBDataSize *= pInfo->pDibBuf[0]->biHeight;

	//  _CAOĂяoB
	saveInfo.dwRate = aviStreamInfo.dwRate;
	if ((hInst = GetModuleHandle("AVISAVE.DLL")) == NULL) {
		MessageBox(NULL, "W[̃nh擾ł܂", "AVISave.dll", MB_OK | MB_ICONEXCLAMATION);
		return FALSE;
	}
	if (DialogBoxParam(hInst, MAKEINTRESOURCE(IDD_SAVEDIALOG), NULL, (DLGPROC)SaveDlgProc, (LPARAM)&saveInfo)!=IDOK) {
		return FALSE;
	}
	aviStreamInfo.dwRate = saveInfo.dwRate;

	//  AVI Filȅ
	AVIFileInit();
	if (AVIFileOpen(&paviFile, fileName, OF_CREATE | OF_WRITE | OF_SHARE_DENY_NONE, NULL)!=0) {
		AVIFileExit();
		return FALSE;
	}
	if (AVIFileCreateStream(paviFile, &paviStream, &aviStreamInfo)!=0) {
		AVIFileRelease(paviFile);
		AVIFileExit();
		return FALSE;
	}

	//  ݃[v	f iꂽ摜f[^ԍO͏݂܂j
	for (dwCountPic = 0; dwCountPic < (pInfo->nPicture-1); dwCountPic++) {
		//  Xg[Ƀwb_[ƃpbg
		if (dwCountPic == 0 && AVIStreamSetFormat(paviStream, dwCountPic, pInfo->pDibBuf[0], dwHAPSize)!=0) {
			AVIStreamRelease(paviStream);
			AVIFileRelease(paviFile);
			AVIFileExit();
			return FALSE;
		}
		//  Xg[ɏ
		if (AVIStreamWrite(paviStream, dwCountPic, 1, pInfo->pBitBuf[dwCountPic+1], dwDIBDataSize, AVIIF_KEYFRAME, NULL, NULL)!=0) {
			AVIStreamRelease(paviStream);
			AVIFileRelease(paviFile);
			AVIFileExit();
			return FALSE;
		}
	}

	//  AVI Filě㏈
	AVIStreamRelease(paviStream);
	AVIFileRelease(paviFile);
	AVIFileExit();

	return TRUE;
}

/******************************************************************************/
/*                                                                            */
/*  _CAOEC֐                                                    */
/*                                                                            */
/******************************************************************************/

BOOL CALLBACK SaveDlgProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	static SAVEDLG saveInfo, *savedlg;

	switch (uMsg) {
		case WM_INITDIALOG:	
			savedlg = (SAVEDLG *)lParam;
			saveInfo = *savedlg;
			SendDlgItemMessage(hDlg, IDC_EDIT_RATE, EM_LIMITTEXT, 4, 0);
			SetDlgItemInt(hDlg, IDC_EDIT_RATE, saveInfo.dwRate, TRUE);
			return TRUE;

		case WM_COMMAND:
			switch (LOWORD(wParam)) {
				case IDOK:
					*savedlg = saveInfo;

				case IDCANCEL:
					EndDialog(hDlg,LOWORD(wParam));

				case IDC_EDIT_RATE:
					saveInfo.dwRate = GetDlgItemInt(hDlg, IDC_EDIT_RATE, NULL, TRUE);
					if (saveInfo.dwRate < 1){
						saveInfo.dwRate = 1;
						SetDlgItemInt(hDlg, IDC_EDIT_RATE, saveInfo.dwRate, TRUE);
					} else if (saveInfo.dwRate > 300){
						saveInfo.dwRate = 300;
						SetDlgItemInt(hDlg, IDC_EDIT_RATE, saveInfo.dwRate, TRUE);
					}
					return TRUE;
			}
			return TRUE;
	}
	return FALSE;
}
